diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/keyframe_selection.cc svn/extern/libmv/libmv/simple_pipeline/keyframe_selection.cc
--- trunk/extern/libmv/libmv/simple_pipeline/keyframe_selection.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/keyframe_selection.cc	2013-09-18 10:21:40.000000000 +0100
@@ -20,6 +20,8 @@
 
 #include "libmv/simple_pipeline/keyframe_selection.h"
 
+#include <vector>
+
 #include "libmv/numeric/numeric.h"
 #include "ceres/ceres.h"
 #include "libmv/logging/logging.h"
@@ -97,7 +99,7 @@
 };
 
 void ComputeHomographyFromCorrespondences(const Mat &x1, const Mat &x2,
-                                          CameraIntrinsics &intrinsics,
+                                          const CameraIntrinsics &intrinsics,
                                           Mat3 *H) {
   // Algebraic homography estimation, happens with normalized coordinates
   Homography2DFromCorrespondencesLinear(x1, x2, H, 1e-12);
@@ -172,7 +174,7 @@
 };
 
 void ComputeFundamentalFromCorrespondences(const Mat &x1, const Mat &x2,
-                                           CameraIntrinsics &intrinsics,
+                                           const CameraIntrinsics &intrinsics,
                                            Mat3 *F) {
   // Algebraic fundamental estimation, happens with normalized coordinates
   NormalizedEightPointSolver(x1, x2, F);
@@ -288,15 +290,20 @@
 }
 }  // namespace
 
-void SelectKeyframesBasedOnGRICAndVariance(const Tracks &tracks,
-                                           CameraIntrinsics &intrinsics,
-                                           vector<int> &keyframes) {
+void SelectKeyframesBasedOnGRICAndVariance(
+    const Tracks &tracks,
+    const std::vector<CameraIntrinsics> &intrinsics,
+    int camera,
+    vector<int> &keyframes) {
   // Mirza Tahir Ahmed, Matthew N. Dailey
   // Robust key frame extraction for 3D reconstruction from video streams
   //
   // http://www.cs.ait.ac.th/~mdailey/papers/Tahir-KeyFrame.pdf
 
-  int max_image = tracks.MaxImage();
+  Tracks camera_tracks(tracks.MarkersForCamera(camera));
+  const CameraIntrinsics &camera_intrinsics = intrinsics[camera];
+
+  int max_image = camera_tracks.MaxImage();
   int next_keyframe = 1;
   int number_keyframes = 0;
 
@@ -308,7 +315,7 @@
   const double Tmin = 0.8;
   const double Tmax = 1.0;
 
-  Mat3 N = IntrinsicsNormalizationMatrix(intrinsics);
+  Mat3 N = IntrinsicsNormalizationMatrix(camera_intrinsics);
   Mat3 N_inverse = N.inverse();
 
   double Sc_best = std::numeric_limits<double>::max();
@@ -328,11 +335,11 @@
          candidate_image++) {
       // Conjunction of all markers from both keyframes
       vector<Marker> all_markers =
-        tracks.MarkersInBothImages(current_keyframe, candidate_image);
+        camera_tracks.MarkersInBothImages(current_keyframe, candidate_image);
 
       // Match keypoints between frames current_keyframe and candidate_image
       vector<Marker> tracked_markers =
-        tracks.MarkersForTracksInBothImages(current_keyframe, candidate_image);
+        camera_tracks.MarkersForTracksInBothImages(current_keyframe, candidate_image);
 
       // Correspondences in normalized space
       Mat x1, x2;
@@ -360,8 +367,8 @@
         continue;
 
       Mat3 H, F;
-      ComputeHomographyFromCorrespondences(x1, x2, intrinsics, &H);
-      ComputeFundamentalFromCorrespondences(x1, x2, intrinsics, &F);
+      ComputeHomographyFromCorrespondences(x1, x2, camera_intrinsics, &H);
+      ComputeFundamentalFromCorrespondences(x1, x2, camera_intrinsics, &F);
 
       // TODO(sergey): STEP 2: Discard outlier matches
 
@@ -373,9 +380,9 @@
       F_e.resize(x1.cols());
       for (int i = 0; i < x1.cols(); i++) {
         Vec2 current_x1 =
-          NorrmalizedToPixelSpace(Vec2(x1(0, i), x1(1, i)), intrinsics);
+          NorrmalizedToPixelSpace(Vec2(x1(0, i), x1(1, i)), camera_intrinsics);
         Vec2 current_x2 =
-          NorrmalizedToPixelSpace(Vec2(x2(0, i), x2(1, i)), intrinsics);
+          NorrmalizedToPixelSpace(Vec2(x2(0, i), x2(1, i)), camera_intrinsics);
 
         H_e(i) = SymmetricGeometricDistance(H, current_x1, current_x2);
         F_e(i) = SymmetricEpipolarDistance(F, current_x1, current_x2);
@@ -442,10 +449,11 @@
          << "\nt:" << t.transpose();
 
       // First camera is identity, second one is relative to it
-      reconstruction.InsertCamera(current_keyframe,
-                                  Mat3::Identity(),
-                                  Vec3::Zero());
-      reconstruction.InsertCamera(candidate_image, R, t);
+      reconstruction.InsertView(current_keyframe,
+                                Mat3::Identity(),
+                                Vec3::Zero(),
+                                camera);
+      reconstruction.InsertView(candidate_image, R, t, camera);
 
       // Reconstruct 3D points
       int intersects_total = 0, intersects_success = 0;
@@ -494,15 +502,15 @@
       success_intersects_factor_best = success_intersects_factor;
 
       Tracks two_frames_tracks(tracked_markers);
-      CameraIntrinsics empty_intrinsics;
+      std::vector<CameraIntrinsics> empty_intrinsics;
       BundleEvaluation evaluation;
       evaluation.evaluate_jacobian = true;
 
+      BundleOptions bundle_options;
       EuclideanBundleCommonIntrinsics(two_frames_tracks,
-                                      BUNDLE_NO_INTRINSICS,
-                                      BUNDLE_NO_CONSTRAINTS,
+                                      bundle_options,
                                       &reconstruction,
-                                      &empty_intrinsics,
+                                      empty_intrinsics,
                                       &evaluation);
 
       Mat &jacobian = evaluation.jacobian;
@@ -579,4 +587,11 @@
   }
 }
 
+void SelectKeyframesBasedOnGRICAndVariance(
+    const Tracks &tracks,
+    const std::vector<CameraIntrinsics> &intrinsics,
+    vector<int> &keyframes) {
+  SelectKeyframesBasedOnGRICAndVariance(tracks, intrinsics, 0, keyframes);
+}
+
 }  // namespace libmv
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/keyframe_selection.h svn/extern/libmv/libmv/simple_pipeline/keyframe_selection.h
--- trunk/extern/libmv/libmv/simple_pipeline/keyframe_selection.h	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/keyframe_selection.h	2013-09-14 11:24:31.000000000 +0100
@@ -21,31 +21,42 @@
 #ifndef LIBMV_SIMPLE_PIPELINE_KEYFRAME_SELECTION_H_
 #define LIBMV_SIMPLE_PIPELINE_KEYFRAME_SELECTION_H_
 
+#include <vector>
+
 #include "libmv/base/vector.h"
 #include "libmv/simple_pipeline/tracks.h"
 #include "libmv/simple_pipeline/camera_intrinsics.h"
 
 namespace libmv {
 
-// Get list of all images which are good enough to be as keyframes from
-// camera reconstruction. Based on GRIC criteria and uses Pollefeys'
-// approach for correspondence ratio constraint.
+// Get list of all images from given camera which are good enough to be as
+// keyframes for camera reconstruction. Based on GRIC criteria and uses
+// Pollefeys' approach for correspondence ratio constraint.
 //
-// As an additional, additional criteria based on reconstruction
-// variance is used. This means if correspondence and GRIC criteria
-// are passed, two-frames reconstruction using candidate keyframes
-// happens. After reconstruction variance of 3D points is calculating
-// and if expected error estimation is too large, keyframe candidate
-// is rejecting.
+// Additional criteria based on reconstruction variance are used. This means if
+// correspondence and GRIC criteria are passed, two-frame reconstruction using
+// candidate keyframes happens. After reconstruction, the variance of 3D points
+// is calculated and, if the expected error estimation is too large, the keyframe
+// candidate is rejected.
 //
 // \param tracks contains all tracked correspondences between frames
 //        expected to be undistorted and normalized
 // \param intrinsics is camera intrinsics
 // \param keyframes will contain all images number which are considered
 //        good to be used for reconstruction
-void SelectKeyframesBasedOnGRICAndVariance(const Tracks &tracks,
-                                           CameraIntrinsics &intrinsics,
-                                           vector<int> &keyframes);
+//
+// TODO(sftrabbit): Use algorithm that finds images of high variance from
+//                  multiple cameras.
+void SelectKeyframesBasedOnGRICAndVariance(
+    const Tracks &tracks,
+    const std::vector<CameraIntrinsics> &intrinsics,
+    int camera,
+    vector<int> &keyframes);
+
+void SelectKeyframesBasedOnGRICAndVariance(
+    const Tracks &tracks,
+    const std::vector<CameraIntrinsics> &intrinsics,
+    vector<int> &keyframes);
 
 }  // namespace libmv
 
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/modal_solver.cc svn/extern/libmv/libmv/simple_pipeline/modal_solver.cc
--- trunk/extern/libmv/libmv/simple_pipeline/modal_solver.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/modal_solver.cc	2013-09-14 11:24:31.000000000 +0100
@@ -99,8 +99,11 @@
 void ModalSolver(const Tracks &tracks,
                  EuclideanReconstruction *reconstruction,
                  ProgressUpdateCallback *update_callback) {
-  int max_image = tracks.MaxImage();
-  int max_track = tracks.MaxTrack();
+  static const int kModalCamera = 0;
+  Tracks camera_tracks(tracks.MarkersForCamera(kModalCamera));
+
+  int max_image = camera_tracks.MaxImage();
+  int max_track = camera_tracks.MaxTrack();
 
   LG << "Max image: " << max_image;
   LG << "Max track: " << max_track;
@@ -111,12 +114,12 @@
   ceres::AngleAxisToQuaternion(&zero_rotation(0), &quaternion(0));
 
   for (int image = 0; image <= max_image; ++image) {
-    vector<Marker> all_markers = tracks.MarkersInImage(image);
+    vector<Marker> image_markers = camera_tracks.MarkersInImage(image);
 
     ModalSolverLogProress(update_callback, (float) image / max_image);
 
     // Skip empty images without doing anything.
-    if (all_markers.size() == 0) {
+    if (image_markers.size() == 0) {
       LG << "Skipping image: " << image;
       continue;
     }
@@ -124,13 +127,12 @@
     // STEP 1: Estimate rotation analytically.
     Mat3 current_R;
     ceres::QuaternionToRotation(&quaternion(0), &current_R(0, 0));
-
     // Construct point cloud for current and previous images,
     // using markers appear at current image for which we know
     // 3D positions.
     Mat x1, x2;
-    for (int i = 0; i < all_markers.size(); ++i) {
-      Marker &marker = all_markers[i];
+    for (int i = 0; i < image_markers.size(); ++i) {
+      Marker &marker = image_markers[i];
       EuclideanPoint *point = reconstruction->PointForTrack(marker.track);
       if (point) {
         Vec3 X;
@@ -176,8 +178,8 @@
         new ceres::QuaternionParameterization;
 
     int num_residuals = 0;
-    for (int i = 0; i < all_markers.size(); ++i) {
-      Marker &marker = all_markers[i];
+    for (int i = 0; i < image_markers.size(); ++i) {
+      Marker &marker = image_markers[i];
       EuclideanPoint *point = reconstruction->PointForTrack(marker.track);
 
       if (point) {
@@ -218,7 +220,7 @@
     // Convert quaternion to rotation matrix.
     Mat3 R;
     ceres::QuaternionToRotation(&quaternion(0), &R(0, 0));
-    reconstruction->InsertCamera(image, R, Vec3::Zero());
+    reconstruction->InsertView(image, R, Vec3::Zero(), kModalCamera);
 
     // STEP 3: reproject all new markers appeared at image
 
@@ -226,7 +228,7 @@
     // and reproject them on sphere to obtain 3D position/
     for (int track = 0; track <= max_track; ++track) {
       if (!reconstruction->PointForTrack(track)) {
-        Marker marker = tracks.MarkerInImageForTrack(image, track);
+        Marker marker = camera_tracks.MarkerInImageForTrack(image, track);
 
         if (marker.image == image) {
           // New track appeared on this image,
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/modal_solver.h svn/extern/libmv/libmv/simple_pipeline/modal_solver.h
--- trunk/extern/libmv/libmv/simple_pipeline/modal_solver.h	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/modal_solver.h	2013-09-14 11:24:31.000000000 +0100
@@ -29,15 +29,16 @@
 
 /*!
     This solver solves such camera motion as tripod rotation, reconstructing
-    only camera motion itself. Bundles are not reconstructing properly, they're
-    just getting projected onto sphere.
+    only camera motion itself. Bundles are not reconstructing properly; they're
+    projected onto sphere.
 
-    Markers from tracks object would be used for recosntruction, and algorithm
-    assumes thir's positions are undistorted already and they're in nnormalized
-    space.
+    Markers from tracks object are used for reconstruction. The algorithm
+    assumes their positions are undistorted already and that they're in
+    normalized space.
 
-    Reconstructed cameras and projected bundles would be added to reconstruction
-    object.
+    Reconstructed cameras and projected bundles are added to the given
+    reconstruction object. Only camera 0 is reconstructed, using only the
+    markers associated with camera 0.
 */
 void ModalSolver(const Tracks &tracks,
                  EuclideanReconstruction *reconstruction,
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/pipeline.cc svn/extern/libmv/libmv/simple_pipeline/pipeline.cc
--- trunk/extern/libmv/libmv/simple_pipeline/pipeline.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/pipeline.cc	2013-09-14 12:02:39.000000000 +0100
@@ -43,7 +43,7 @@
 // template bloat and making interface changes much easier.
 struct EuclideanPipelineRoutines {
   typedef EuclideanReconstruction Reconstruction;
-  typedef EuclideanCamera Camera;
+  typedef EuclideanView View;
   typedef EuclideanPoint Point;
 
   static void Bundle(const Tracks &tracks,
@@ -63,9 +63,9 @@
   }
 
   static Marker ProjectMarker(const EuclideanPoint &point,
-                              const EuclideanCamera &camera,
+                              const EuclideanView &view,
                               const CameraIntrinsics &intrinsics) {
-    Vec3 projected = camera.R * point.X + camera.t;
+    Vec3 projected = view.R * point.X + view.t;
     projected /= projected(2);
 
     Marker reprojected_marker;
@@ -74,7 +74,7 @@
                                &reprojected_marker.x,
                                &reprojected_marker.y);
 
-    reprojected_marker.image = camera.image;
+    reprojected_marker.image = view.image;
     reprojected_marker.track = point.track;
     return reprojected_marker;
   }
@@ -82,7 +82,7 @@
 
 struct ProjectivePipelineRoutines {
   typedef ProjectiveReconstruction Reconstruction;
-  typedef ProjectiveCamera Camera;
+  typedef ProjectiveView View;
   typedef ProjectivePoint Point;
 
   static void Bundle(const Tracks &tracks,
@@ -105,9 +105,9 @@
   }
 
   static Marker ProjectMarker(const ProjectivePoint &point,
-                              const ProjectiveCamera &camera,
+                              const ProjectiveView &view,
                               const CameraIntrinsics &intrinsics) {
-    Vec3 projected = camera.P * point.X;
+    Vec3 projected = view.P * point.X;
     projected /= projected(2);
 
     Marker reprojected_marker;
@@ -116,7 +116,7 @@
                                &reprojected_marker.x,
                                &reprojected_marker.y);
 
-    reprojected_marker.image = camera.image;
+    reprojected_marker.image = view.image;
     reprojected_marker.track = point.track;
     return reprojected_marker;
   }
@@ -169,7 +169,7 @@
 
       vector<Marker> reconstructed_markers;
       for (int i = 0; i < all_markers.size(); ++i) {
-        if (reconstruction->CameraForImage(all_markers[i].image)) {
+        if (reconstruction->ViewForImage(all_markers[i].image)) {
           reconstructed_markers.push_back(all_markers[i]);
         }
       }
@@ -199,7 +199,7 @@
     // Do all possible resections.
     num_resects = 0;
     for (int image = 0; image <= max_image; ++image) {
-      if (reconstruction->CameraForImage(image)) {
+      if (reconstruction->ViewForImage(image)) {
         LG << "Skipping frame: " << image;
         continue;
       }
@@ -239,7 +239,7 @@
   // One last pass...
   num_resects = 0;
   for (int image = 0; image <= max_image; ++image) {
-    if (reconstruction->CameraForImage(image)) {
+    if (reconstruction->ViewForImage(image)) {
       LG << "Skipping frame: " << image;
       continue;
     }
@@ -275,24 +275,24 @@
 double InternalReprojectionError(
         const Tracks &image_tracks,
         const typename PipelineRoutines::Reconstruction &reconstruction,
-        const CameraIntrinsics &intrinsics) {
+        const std::vector<CameraIntrinsics> &intrinsics) {
   int num_skipped = 0;
   int num_reprojected = 0;
   double total_error = 0.0;
   vector<Marker> markers = image_tracks.AllMarkers();
   for (int i = 0; i < markers.size(); ++i) {
-    const typename PipelineRoutines::Camera *camera =
-        reconstruction.CameraForImage(markers[i].image);
+    const typename PipelineRoutines::View *view =
+        reconstruction.ViewForImage(markers[i].image);
     const typename PipelineRoutines::Point *point =
         reconstruction.PointForTrack(markers[i].track);
-    if (!camera || !point) {
+    if (!view || !point) {
       num_skipped++;
       continue;
     }
     num_reprojected++;
 
     Marker reprojected_marker =
-        PipelineRoutines::ProjectMarker(*point, *camera, intrinsics);
+        PipelineRoutines::ProjectMarker(*point, *view, intrinsics[markers[i].camera]);
     double ex = reprojected_marker.x - markers[i].x;
     double ey = reprojected_marker.y - markers[i].y;
 
@@ -326,16 +326,15 @@
 
 double EuclideanReprojectionError(const Tracks &image_tracks,
                                   const EuclideanReconstruction &reconstruction,
-                                  const CameraIntrinsics &intrinsics) {
+                                  const std::vector<CameraIntrinsics> &intrinsics) {
   return InternalReprojectionError<EuclideanPipelineRoutines>(image_tracks,
                                                               reconstruction,
                                                               intrinsics);
 }
 
-double ProjectiveReprojectionError(
-    const Tracks &image_tracks,
-    const ProjectiveReconstruction &reconstruction,
-    const CameraIntrinsics &intrinsics) {
+double ProjectiveReprojectionError(const Tracks &image_tracks,
+                                   const ProjectiveReconstruction &reconstruction,
+                                   const std::vector<CameraIntrinsics> &intrinsics) {
   return InternalReprojectionError<ProjectivePipelineRoutines>(image_tracks,
                                                                reconstruction,
                                                                intrinsics);
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/pipeline.h svn/extern/libmv/libmv/simple_pipeline/pipeline.h
--- trunk/extern/libmv/libmv/simple_pipeline/pipeline.h	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/pipeline.h	2013-09-14 11:24:31.000000000 +0100
@@ -21,6 +21,8 @@
 #ifndef LIBMV_SIMPLE_PIPELINE_PIPELINE_H_
 #define LIBMV_SIMPLE_PIPELINE_PIPELINE_H_
 
+#include <vector>
+
 #include "libmv/simple_pipeline/callbacks.h"
 #include "libmv/simple_pipeline/tracks.h"
 #include "libmv/simple_pipeline/reconstruction.h"
@@ -90,12 +92,11 @@
 
 double EuclideanReprojectionError(const Tracks &image_tracks,
                                   const EuclideanReconstruction &reconstruction,
-                                  const CameraIntrinsics &intrinsics);
+                                  const std::vector<CameraIntrinsics> &intrinsics);
 
-double ProjectiveReprojectionError(
-    const Tracks &image_tracks,
-    const ProjectiveReconstruction &reconstruction,
-    const CameraIntrinsics &intrinsics);
+double ProjectiveReprojectionError(const Tracks &image_tracks,
+                                   const ProjectiveReconstruction &reconstruction,
+                                   const std::vector<CameraIntrinsics> &intrinsics);
 
 void InvertIntrinsicsForTracks(const Tracks &raw_tracks,
                                const CameraIntrinsics &camera_intrinsics,
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/reconstruction.cc svn/extern/libmv/libmv/simple_pipeline/reconstruction.cc
--- trunk/extern/libmv/libmv/simple_pipeline/reconstruction.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/reconstruction.cc	2013-09-14 11:59:33.000000000 +0100
@@ -18,6 +18,8 @@
 // FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 // IN THE SOFTWARE.
 
+#include <vector>
+
 #include "libmv/simple_pipeline/reconstruction.h"
 #include "libmv/numeric/numeric.h"
 #include "libmv/logging/logging.h"
@@ -27,29 +29,32 @@
 EuclideanReconstruction::EuclideanReconstruction() {}
 EuclideanReconstruction::EuclideanReconstruction(
     const EuclideanReconstruction &other) {
-  cameras_ = other.cameras_;
+  views_ = other.views_;
   points_ = other.points_;
 }
 
 EuclideanReconstruction &EuclideanReconstruction::operator=(
     const EuclideanReconstruction &other) {
   if (&other != this) {
-    cameras_ = other.cameras_;
+    views_ = other.views_;
     points_ = other.points_;
   }
   return *this;
 }
 
-void EuclideanReconstruction::InsertCamera(int image,
-                                           const Mat3 &R,
-                                           const Vec3 &t) {
-  LG << "InsertCamera " << image << ":\nR:\n"<< R << "\nt:\n" << t;
-  if (image >= cameras_.size()) {
-    cameras_.resize(image + 1);
-  }
-  cameras_[image].image = image;
-  cameras_[image].R = R;
-  cameras_[image].t = t;
+void EuclideanReconstruction::InsertView(int image,
+                                         const Mat3 &R,
+                                         const Vec3 &t,
+                                         int camera) {
+  LG << "InsertView camera " << camera << ", image " << image
+     << ":\nR:\n"<< R << "\nt:\n" << t;
+  if (image >= views_.size()) {
+    views_.resize(image + 1);
+  }
+  views_[image].image = image;
+  views_[image].R = R;
+  views_[image].t = t;
+  views_[image].camera = camera;
 }
 
 void EuclideanReconstruction::InsertPoint(int track, const Vec3 &X) {
@@ -61,32 +66,43 @@
   points_[track].X = X;
 }
 
-EuclideanCamera *EuclideanReconstruction::CameraForImage(int image) {
-  return const_cast<EuclideanCamera *>(
+EuclideanView *EuclideanReconstruction::ViewForImage(int image) {
+  return const_cast<EuclideanView *>(
       static_cast<const EuclideanReconstruction *>(
-          this)->CameraForImage(image));
+          this)->ViewForImage(image));
 }
 
-const EuclideanCamera *EuclideanReconstruction::CameraForImage(
-    int image) const {
-  if (image < 0 || image >= cameras_.size()) {
+const EuclideanView *EuclideanReconstruction::ViewForImage(int image) const {
+  if (image < 0 || image >= views_.size()) {
     return NULL;
   }
-  const EuclideanCamera *camera = &cameras_[image];
-  if (camera->image == -1) {
+  const EuclideanView *view = &views_[image];
+  if (view->camera == -1 || view->image == -1) {
     return NULL;
   }
-  return camera;
+  return view;
+}
+
+vector<EuclideanView> EuclideanReconstruction::AllViews(
+    ) const {
+  vector<EuclideanView> views;
+  for (int i = 0; i < views_.size(); ++i) {
+    if (views_[i].camera != -1 && views_[i].image != -1) {
+      views.push_back(views_[i]);
+    }
+  }
+  return views;
 }
 
-vector<EuclideanCamera> EuclideanReconstruction::AllCameras() const {
-  vector<EuclideanCamera> cameras;
-  for (int i = 0; i < cameras_.size(); ++i) {
-    if (cameras_[i].image != -1) {
-      cameras.push_back(cameras_[i]);
+vector<EuclideanView> EuclideanReconstruction::AllViewsForCamera(
+    int camera) const {
+  vector<EuclideanView> views;
+  for (int i = 0; i < views_.size(); ++i) {
+    if (views_[i].image != -1 && views_[i].camera == camera) {
+      views.push_back(views_[i]);
     }
   }
-  return cameras;
+  return views;
 }
 
 EuclideanPoint *EuclideanReconstruction::PointForTrack(int track) {
@@ -115,14 +131,17 @@
   return points;
 }
 
-void ProjectiveReconstruction::InsertCamera(int image,
-                                           const Mat34 &P) {
-  LG << "InsertCamera " << image << ":\nP:\n"<< P;
-  if (image >= cameras_.size()) {
-    cameras_.resize(image + 1);
-  }
-  cameras_[image].image = image;
-  cameras_[image].P = P;
+void ProjectiveReconstruction::InsertView(int image,
+                                          const Mat34 &P,
+                                          int camera) {
+  LG << "InsertView camera " << camera << ", image " << image
+     << ":\nP:\n"<< P;
+  if (image >= views_.size()) {
+    views_.resize(image + 1);
+  }
+  views_[image].image = image;
+  views_[image].P = P;
+  views_[image].camera = camera;
 }
 
 void ProjectiveReconstruction::InsertPoint(int track, const Vec4 &X) {
@@ -134,32 +153,42 @@
   points_[track].X = X;
 }
 
-ProjectiveCamera *ProjectiveReconstruction::CameraForImage(int image) {
-  return const_cast<ProjectiveCamera *>(
+ProjectiveView *ProjectiveReconstruction::ViewForImage(int image) {
+  return const_cast<ProjectiveView *>(
       static_cast<const ProjectiveReconstruction *>(
-          this)->CameraForImage(image));
+          this)->ViewForImage(image));
 }
 
-const ProjectiveCamera *ProjectiveReconstruction::CameraForImage(
-    int image) const {
-  if (image < 0 || image >= cameras_.size()) {
+const ProjectiveView *ProjectiveReconstruction::ViewForImage(int image) const {
+  if (image < 0 || image >= views_.size()) {
     return NULL;
   }
-  const ProjectiveCamera *camera = &cameras_[image];
-  if (camera->image == -1) {
+  const ProjectiveView *view = &views_[image];
+  if (view->camera == -1 || view->image == -1) {
     return NULL;
   }
-  return camera;
+  return view;
+}
+
+vector<ProjectiveView> ProjectiveReconstruction::AllViews() const {
+  vector<ProjectiveView> views;
+  for (int i = 0; i < views_.size(); ++i) {
+    if (views_[i].camera != 1 && views_[i].image != -1) {
+      views.push_back(views_[i]);
+    }
+  }
+  return views;
 }
 
-vector<ProjectiveCamera> ProjectiveReconstruction::AllCameras() const {
-  vector<ProjectiveCamera> cameras;
-  for (int i = 0; i < cameras_.size(); ++i) {
-    if (cameras_[i].image != -1) {
-      cameras.push_back(cameras_[i]);
+vector<ProjectiveView> ProjectiveReconstruction::AllViewsForCamera(
+    int camera) const {
+  vector<ProjectiveView> views;
+  for (int i = 0; i < views_.size(); ++i) {
+    if (views_[i].image != -1 && views_[i].camera == camera) {
+      views.push_back(views_[i]);
     }
   }
-  return cameras;
+  return views;
 }
 
 ProjectivePoint *ProjectiveReconstruction::PointForTrack(int track) {
